;============================================================================;
;                                 dialog.asm                                 ;


;============================================================================;
;dialog_window\open                                                          ;
;    Input     : d4.w = width                                                ;
;                d5.w = height                                               ;
;                d6.w = first button type                                    ;
;                d7.w = second button type                                   ;
;    Output    : draw a dialog window                                        ;
;    Destroyed : a0-a1                                                       ;

dialog_window\open
         movem.w    d0-d3,-(a7)
         lea        dialog_window\size(pc),a1
         move.w     d4,4(a1)
         move.w     #lcd_width,d0
         sub.w      d4,d0
         lsr.w      #1,d0
         move.w     d0,(a1)
         add.w      d0,4(a1)
         move.w     d5,6(a1)
         move.w     #lcd_height,d1
         sub.w      d5,d1
         lsr.w      #1,d1
         move.w     d1,2(a1)
         add.w      d1,6(a1)
         move.l     a0,-(a7)
         move.w	    #%0001000000011000,-(a7)    ; has a title, a rounded
         pea        dialog_window\size(pc)      ; border, and saves screen
         pea        dialog_window(pc)
         jsr        tios::WinOpen
     ;tst.b     d0
     ;beq	   error                <--- NE PAS OUBLIER
         jsr	    tios::WinActivate

         move.w     #window_font,4(a7)
         jsr        tios::WinFont

         move.w     #left_button\offset,6(a7)
         move.w     d6,4(a7)
         jsr        tios::DrawStaticButton
         move.w     d4,6(a7)
         sub.w      #right_button\offset,6(a7)
         move.w     d7,4(a7)
         jsr        tios::DrawStaticButton
         lea        14(a7),a7
         movem.w    (a7)+,d0-d3
         rts

;============================================================================;
;dialog_window\pause_and_clear                                               ;
;    Input     : void                                                        ;
;    Output    : clear the dialog window                                     ;
;    Destroyed : void                                                        ;

dialog_window\pause_and_clear
         bsr        wait_for_no_key
         bsr        pause

;============================================================================;
;dialog_window\clear                                                         ;
;    Input     : void                                                        ;
;    Output    : clear the dialog window                                     ;
;    Destroyed : void                                                        ;

dialog_window\clear
         movem.l    d0-d2/a0-a1,-(a7)
         pea	    dialog_window(pc)
         jsr	    tios::WinClose
         addq.l     #4,a7
         movem.l    (a7)+,d0-d2/a0-a1
         rts

;                                 dialog.asm                                 ;
;============================================================================;