;============================================================================;
;                                 system.asm                                 ;

system\interrupts_off
         movem.l    a5-a6,-(a7)
         lea        system\old_handlers(pc),a5
         move.l     #$40064,a6
         move.l     (a6)+,(a5)+
         move.l     (a6)+,(a5)+
         move.l     (a6)+,(a5)+
         move.l     (a6)+,(a5)+
         move.l     (a6)+,(a5)+
         move.l     (a6)+,(a5)+
         move.l     (a6),(a5)
         lea        -24(a6),a6
         lea        system\null_interrupt_handler(pc),a5
         move.l     a5,(a6)+            ; handler 1
         move.l     a5,(a6)+            ; handler 2
         move.l     a5,(a6)+            ; handler 3
         move.l     a5,(a6)+            ; handler 4
         move.l     #system\handler_5,(a6)+
         move.l     a5,(a6)+            ; handler 6
         move.l     a5,(a6)             ; handler 7
         movem.l    (a7)+,a5-a6
         rts

system\interrupts_on
         movem.l    a5-a6,-(a7)
         lea        system\old_handlers(pc),a5
         move.l     #$40064,a6
         move.l     (a5)+,(a6)+
         move.l     (a5)+,(a6)+
         move.l     (a5)+,(a6)+
         move.l     (a5)+,(a6)+
         move.l     (a5)+,(a6)+
         move.l     (a5)+,(a6)+
         move.l     (a5),(a6)
         movem.l    (a7)+,a5-a6
         rts

system\partial_interrupts_off
         move.l     #system\null_interrupt_handler,($40064)     ; handler 1
         move.l     #system\null_interrupt_handler,($40068)     ; handler 2
         rts

system\partial_interrupts_on
         move.l     system\old_handler_1(pc),($40064)
         move.l     system\old_handler_2(pc),($40068)
         rts

system\handler_5
         addq.l     #1,apd\calls_5
         addq.l     #1,timer_20
         addq.l     #1,timer_20_2
         movem.l    d0-d1,-(a7)
         jsr        userlib::get_APD
         move.l     d0,d1
         lsl.l      #2,d1
         lsl.l      #4,d0
         add.l      d1,d0
         sub.l      apd\calls_5(pc),d0
         sle.b      apd\shut_down_if_idle
         movem.l    (a7)+,d0-d1
         rte

system\null_interrupt_handler
         rte

;                                 system.asm                                 ;
;============================================================================;